; CLINE.LSP
; Composite line V1.5 27Jan87
; (C) Copyright 1987 Michael Slinn

(DeFun C:CL ()
 (SetQ SAVB (GetVar "blipmode"))
 (SetQ SAVC (GetVar "cmdecho"))
 (SetQ SAVH (GetVar "highlight"))
 (SetQ SAVS (GetVar "osmode"))
 (SetVar "blipmode" 0)
 (SetVar "cmdecho" 1)
 (SetVar "highlight" 0)
 (SetVar "osmode" 0)
 (If (/= SAVS 0)
  (ProgN
   (PRTM (List
    "\nOSNAP off: Use end, mid, etc.\n"
    "Press RETURN\n"))
   (GetString)))
 (GraphScr)
 (SetQ RTOD (/ 180.0 pi))
 (SetQ STRT (GetPoint "From point: "))
 (SetQ L1 STRT)
 (TerPri)
 (SetQ *Error* DEND)
 (While T
  (If (Eq BLIT T)
   (SetQ BlockSS (SSAdd)))
  (GraphScr)
  (If (>= VRSN 2.0)
   (SetQ LL (GetPoint L1 "To point: "))
   (SetQ LL (GetPoint "To point: ")))
  (If (Null LL)
   (exit)
   (SetQ L2 LL))
  (CLINE)
  (If (Eq BLIT T)
   (BLLN))))

(DeFun BLLN ( / C) ; Build v2.5 Block
 (SetQ BNAM (StrCat BPFX (ItoA BNUM)))
 (Command "block" BNAM L1 BlockSS "")
 (Command "insert" BNAM L1 1 1 0)
 (SetQ BNUM (1+ BNUM))
 (If (> BNUM 9999)
  (ProgN
   (TextScr)
   (PRTM (List
    "\nMax block usage\n"
    "New block name:\n"))
   (SetQ BPFX
    (StrCat
     (SubStr BPFX 1
      (1- (SetQ C (StrLen BPFX))))
     (Chr (1+ (Ascii (SubStr BPFX C))))))
   (SetQ BNUM 1)
   (BLHD))))

(DeFun BLHD ()
 (TextScr)
 (SetQ BLIT (ASKY
  "Cline segments to form blocks" T))
 (If (Eq BLIT T)
  (ProgN
  (SetQ FRST T)
   (SetQ BP "")
   (While (Or
           (Eq FRST T)
           (> (StrLen BP) 27))
    (SetQ FRST ())
    (PRTM (List
     "Enter unique blockname prefix:\n"
     "<" BPFX "> "))
     (SetQ BP (GetString))
    (TerPri))
   (If (Not (Eq BP ""))
    (SetQ BPFX BP))
   (SetQ FRST T)
   (SetQ BN 0)
   (While (Or
     (Eq FRST T)
     (< BN 1)
     (> BN 9999))
    (SetQ FRST ())
    (PRTM (List
     "Initial block number 1-9999 <"
      BNUM "> "))
    (SetQ BN (GetInt))
    (If (Eq BN ())
     (SetQ BN BNUM))
    (TerPri))
   (If (> BN 0)
    (SetQ BNUM BN))
   (PRTM (List
    "Next Cline block will be named:\n"
     BPFX BNUM "\n")))))

(DeFun CLINE ()
 (SetQ A (Angle L1 L2))
 (SetQ AP (+ A HFPI))
 (SetQ AM (- A HFPI))
 (SetQ DA (* A RTOD))
 (If (< DA 0.0)
  (SetQ DA (+ DA 360.0)))
 (If (And (> DA 90.0) (<= DA 270.0))
  (ProgN
   (SetQ AS AP)
   (SetQ AP AM)
   (SetQ AM AS)))
 (SetQ TA (TXTO DA))
 (Cond
  ((<= (Distance L1 L2) (* MNLN 2.0))
   (Command "line" L1 L2 "")
   (If (Eq BLIT T)
    (ADBL)))
  (T
   (SetQ LP (Polar L1 A MNLN))
   (Command "line" L1 LP "")
   (If (Eq BLIT T)
    (ADBL))
   (While (> (Distance LP L2) MNLN)
    (ForEach CLI CLD
     (SetQ NI (Nth 1 CLI))
     (Cond
      ((Eq "text" NI)
       (SetQ DL (/ (* (StrLen (Nth 6 CLI))
        (Nth 4 CLI) 1.2) 2.0))
       (SetQ NQ (/ (Nth 4 CLI) 2.0))
       (SetQ NP (Polar LP A (* DL 2.0)))
       (SetQ IP (Polar (Polar LP A DL)
        AM NQ)))
      ((Eq "line" NI)
       (SetQ NP (Polar LP A DSH))
       (SetQ DL 0))
      ((Eq "id" NI)             
       (SetQ NP (Polar LP A DSH))
       (SetQ DL 0))
      ((Eq "insert" NI)
       (SetQ DL (* 1.2 (Nth 4 CLI)))
       (SetQ NP (Polar LP A DL))
       (SetQ IP (Polar LP A (/ DL 2.0)))))
     (If (Or
       (< (Distance NP L2) MNLN)
       (< 0.001 (Abs (- A (Angle NP L2)))))
      (ProgN
       (Command "line" LP L2 "")
       (SetQ LP L2))
      (ProgN
       (SetQ LP (Polar LP A DL))
       (Eval CLI)
       (Cond
        ((Eq "insert" NI)
         (SetQ DL 0))
        ((Eq "id" NI)
         (SetQ DL DSH))
        ((Eq "line" NI)
         (SetQ DL DSH)))
       (SetQ LP (Polar LP A DL))))
     (If (Eq BLIT T)
      (ADBL))))
   (Command "line" LP L2 "")
   (If (Eq BLIT T)
    (ADBL))))
 (SetQ L1 L2))

(DeFun ADBL () ; Add item to block list
 (SetQ BlockSS (SSAdd (EntLast) BlockSS)))

(DeFun TXTO (TA) ; Text orientation
 (If (< TA 0.0) (SetQ TA (+ 360.0 TA))) 
 (Cond
  ((<= TA 90.0) 
   (SetQ TA TA))
  ((<= TA 270.0)
   (SetQ TA (- TA 180.0)))
  (T            
   (SetQ TA TA))))

(DeFun DEND (St) ; Capture error codes
 (If (Not (Or
   (Eq St "bad point argument")
   (Eq St "quit / exit abort")
   (Eq St "console break")
   (Eq St "bad point value")
   (Eq St "Function cancelled")))
  (PRTM (List "\n" St 
   ". COMPLINE aborts.\n"))
  (ProgN
   (SetQ *Error* ())
   (Command)
   (If (Not (Eq STRT NEXT))
    (ProgN
    (If (ASKY "Close the polygon" ())
     (ProgN
      (SetQ L2 STRT)
      (CLINE)
      (If (Eq BLIT T)
       (BLLN))))))))
 (SetVar "blipmode"  SAVB)
 (SetVar "cmdecho"   SAVC)
 (SetVar "highlight" SAVH)
 (If (/= SAVS 0)
  (ProgN
   (Princ "\nOSNAP restored")
   (SetVar "osmode" SAVS)))
 (Princ "\n\nAll done...\n")
 (PRTM (List
  "Type CN to define new Cline; "
  "CL for next line, same def'n.\n"))
 ())

(DeFun ASKR (PRMT V / X) ; prompted real
 (PRTM (List "\n" PRMT " <" V ">: "))
 (SetQ X (GetReal))
 (If (Not (Null X))
    (SetQ V X)
    (SetQ V V)))

(DeFun PRTM (Args / A) ; Shows listed args
 (ForEach A Args
      (Princ A)))

(DeFun ASKY (PRMT YN / STRG) ; Prompted YN
 (PRTM (List "\n" PRMT "? <"))
 (If (Not (Null YN))
  (ProgN
   (Princ "Yes")
   (SetQ YN T))
  (ProgN
   (Princ "No")
   (SetQ YN ())))
 (PRTM (List ">: "))
 (SetQ STRG (GetString))
 (If (Or
        (Eq "Y" (SubStr STRG 1 1))
        (Eq "y" (SubStr STRG 1 1)))
        (SetQ YN T))
 (If (Or (Eq "N" (SubStr STRG 1 1))
         (Eq "n" (SubStr STRG 1 1)))
        (SetQ YN ()))
 (SetQ YN YN))

(DeFun C:CN () ; Line definition
 (TextScr)
 (PRTM (List "\nDefine composite line:"))
 (SetQ MNLN (ASKR
  "Min. end line segmt length?" MNLN))
 (SetQ CLD ())
 (PRTM (List
 "\nOK Responses are BDTGX <Return>\n"))
 (SetQ DUN ())
 (While (Null DUN)
  (SetQ X
   (ProgN
    (Princ "Next? <Blk/Dash/Txt/Gap/eXit>: ")
    (SubStr (Read-Line) 1 1)))
  (Cond
   ((Or (Eq X "t")(Eq X "T"))
    (SetQ TS
     (ProgN
      (Princ  "Text string: ")
      (Read-Line)))
    (SetQ HT (ASKR "Text height? " HT))
    (SetQ X (List 'Command "text" "c" 
     'IP HT 'TA TS)))
   ((Or (Eq X "b")(Eq X "B"))
    (SetQ BN (GetString "Block Name: "))
    (SetQ SX (ASKR "X Scale factor: " 1.0))
    (SetQ SY (ASKR "Y Scale factor: " 1.0))
    (SetQ X (List 'Command "insert" BN
     'IP SX SY 'DA)))
   ((Or (Eq X "d")(Eq X "D"))
    (SetQ DSH (ASKR "Dash Length? " DSH))
    (SetQ X (List 'Command "line" 'LP 
     '(Polar LP A DSH) "")))
   ((Or (Eq X "g")(Eq X "G"))
    (SetQ DSH (ASKR "Gap Length? " DSH))
    (SetQ X (List 'Command "id"
     '(Polar LP A DSH))))
   ((Or (Eq X "X")(Eq X "x"))
    (SetQ DUN T))
   (T
    (SetQ X "")
    (Princ "\nInvalid option\n")))
 (If (And (Null DUN) (Not (Eq X "")))
  (SetQ CLD (Cons X CLD))))
 (SetQ CLD (Reverse CLD))
 (If (>= VRSN 2.0)
  (BLHD))
 (C:CL))

(DeFun INITL () ; Initial load procedure
 (SetQ VRSN (atof (substr (Princ (ver)) 18)))
 (terpri)
 (SetQ MNLN 0.5)
 (SetQ DSH (* MNLN 2.0))
 (SetQ HT 0.2)
 (SgnOn)
 (SetQ HFPI (/ pi 2.0))
 (SetQ BPFX "CLINEBLK")
 (SetQ BNUM 1)
 (SetQ BNAM (StrCat BPFX (ItoA BNUM)))
 (SetQ CLD (List
  (List 'Command "text" "c"
   'LP 0.1 'DA "MS")
  (List 'Command "line"
   'LP '(Polar LP A DSH) "")))
 (C:CN)
 ()
)

(DeFun SgnOn () ; For copyright pls leave in
   (PRTM (List
"\nCLINE Composite line drawing routine"
"\n(C) Copyright 1987 Michael Slinn\n\n")))

(INITL)
