

;
;/////////////////////////////////////////////////////////////////////////////
;//                                                                         //
;//                                                                         //
;//                                                                         //
;//                      STANDARD NOTE SELECTION PROGRAM                    //
;//                      Written by Arthur Flood  11/07/92                  //
;//                                                                         //
;//                      email address:  artflood@aol.com                   //
;//                                                                         //
;/////////////////////////////////////////////////////////////////////////////
;




;  This program reads a text file named  "STDNOTES.TXT", searching for notes, 
;  automatically inserting them into an autocad drawing. The program prompts you
;  for the note number. It is not necessary to include the $Dollar sign when  
;  prompted by autocad for the note number. Multiple note numbers can be entered 
;  at a time, but must be separated by a comma or dash.






;  Examples of Ways to Enter Notes:
;
;  >> 1,2,3,4,5,6,7,8         (enters notes 1 thru 8)
;
;  >> 1-8                     (enters notes 1 thru 8)
;
;  >> 1-3,7,8                 (enters notes 1,2,3,7,8)
;






;  Revisions....
;
;  Revised  11-17-92    :  minor changes to allow for different platforms   
;
;  Revised  12-03-92    :  changes made to putnote subroutine
;
;  Revised  12-11-92    :  revised putnum() callout
;
;  Revised  01-22-93    :  added search routine
;
;  Revised  02-24-93    :  revised text height routine
;
;  Revised  03-09-93    :  added routine to check style height 





;  INITIALIZE ROUTINE SETS UP DIFFERENT DEFAULT PATHS FOR SUN AND PC`S

(defun initialize (/ tx height2)

(setq system1 (strcase (getvar "platform")))

;  THE NEXT LINES DETERMINES THE PATH FOR THE SUN SPACSTATION
   (if (= system1 "SUN4/SPARCSTATION") 
   (setq notefile "/network/acad/lisp/stdnotes.txt" system1 "sun")
   (setq system1 "pc")
   )

;  THE NEXT LINES DETERMINES THE PATH FOR PC'S
   (if (= system1 "pc")  
     (setq notefile (findfile "stdnotes.txt"))
   )

;  SET GAP BETWEEN NOTE NUMBERS AND NOTES
;  GAP1 IS THE RATIO BETWEEN GAP AND TEXT HEIGHT
   (setq gap1 6.00)

   (setq textheight (* (getvar "dimscale") 0.15) )
   (setq tx (tblsearch "style" (getvar "textstyle")))
   (setq height2 (cdr(assoc 40 tx)))
     (if (/= height2 0) (progn
     (prompt (chr 7))
     (prompt "\n \nWARNING:  Current style is presently configured to height: ")(princ height2)
     (prompt "\nPlease reconfigure the style to height: 0.00")
     (getstring)
     ))

)



(defun c:getnotes (/ cx filea x1 n num fp1 hh)
(initialize)

(while (= (findfile notefile) nil) 
  (princ (chr 7)) 
  (setq mode "") 
  (prompt "\n \nCannot Find the Standard Notes File:  ")(princ notefile)
  (setq notefile (getstring "\n \nEnter Filename:   "))   
  (if (/= notefile "") (setq flag1 1))
)

(setq cx "")

(while (/= cx "quit")

  (prompt "\nGetnotes Datafile:   ") (princ notefile)(prompt " \n \n")
  (initget  "Search View Insertnote Help Chgheight Load Quit N")
  (setq cx (getkword "Search/View/Help/Quit/Load/Chgheight/InsertNote:  "))
  (if (/= cx nil) (setq cx (strcase cx T)) )

(if (= cx "search")  (setq cx (search)) )

(if (= cx "chgheight") (progn
(prompt "\n \n \n")
(setq hh (strcat "Enter new height <" (rtos textheight 2) "> :  "))
(setq hh (getstring hh))
(if (/= hh "") (setq textheight (atof hh)) )
  (if (= textheight 0) 
  (setq textheight (* (getvar "dimscale") 0.15) )
  )
(setq hh "")
))


(while (or (= cx "goto") (= cx "view")) (progn
(prompt "\n \nEnter starting note number...")
(setq x (strcase (getstring "\n \nGoto note number <1>  :  ") T) )
(if (= x "") (setq x "1"))
(setq num (atoi x))
(setq cx (viewscr num))
))

 (if (or (= cx "insertnote") (= cx "n")) (progn
   (prompt "\nInsert Note into ACAD >>    Example:   1,3,5-9")
   (setq x (getstring "\n \nEnter note numbers:  "))
   (if (/= x "") (progn
   (putacad1 x)
   (if (= status nil) (setq cx "quit") (checkout))
   ))
 ))

 (if (= cx "help") (progn
   (setq x (help1))
   (if (/= x "") (putacad1 x))
 ))

 (if (= cx "load") (progn
   (prompt "The defaut datafile is << STDNOTES.TXT >> ") 
   (setq filea (getstring " \n \nEnter datafile to load <Stdnotes.txt> : "))
   (if (/= filea "") (setq notefile filea)) 
 ))

)

(if (= cx "quit") (prompt "\n \n"))
(princ)
)


(defun putacad1 (x / run1 knt note ff pt0 noteno ix rx pdmde pdpt)
(setq knt 1 pt0 nil lista nil listb nil)
(command "ucs" "w")

(setq status nil pdmde (getvar "pdmode"))
(if (= system1 "sun") (rtn 14) (rtn 2))

(while (and (< knt 20) (/= x nil))
  (setq ff (strcase (substr x 1 1)) ) 
  (if  (or 
       (= ff  "$")  
       (and (>= ff "0") (<= ff "9") )  
       )
     (progn 
     (graphscr) (setq knt 99) 
     (prompt "\n>>  Getting: Note number: ")(princ txt)
     (prompt "\n \n \nThe Drawing Note numbers will be Re-numbered...\n")
     (setq ix (getint "Enter The next available drawing note number  <1> :  "))
     (if (= ix nil) (setq ix 1)) 
        (while (= pt0 nil)
        (setq pt0  (getpoint "\n \n \nPick location for notes.."))
        )
      
     (setvar "pdmode" 2) (command "point" pt0)
     (setq note0 ix pdpt (entlast))

     (setq pt0 (movept pt0 (+ (* gap1 textheight)) 0))
     (setq pt0 (trans pt0 1 0))

     (prompt "\nOne Moment Please....\n \n")
        (if (= ff "$") 
        (setq note (substr x 2 70))
        (setq note (substr x 1 70)) 
        )
     (setq noteno (strcat (rtos ix 5) "    "))
     (setq list1 (parsenum1 note) )
         (foreach tt list1
         (setq rx (putacad2 (atoi tt) pt0 noteno))
         (if (= rx 0) (setq ix (1+ ix) pt0 ""))
         (setq noteno (strcat (rtos ix 5) "    "))
         )
     (entdel pdpt) 
     (if (/= note0 0) (putnum))
     )
     (progn
       (if (and (/= ff "Q") (= flag1 0))   
       (setq ff (getstring "\n \n>>  Do you wish to continue: <Y>  ")) 
       )
     (if (= system1 "sun") (rtn 5) (rtn 2)) 
     )  
  )

  (rtn 3)
  (setq knt (1+ knt))
  (setq ff (strcase ff))

    (if     (or  (= ff "Q") (= ff "N")   ) 
    (progn (graphscr) (setq knt 99) (rtn 3))
    )
  )
(setvar "pdmode" pdmde)
(princ)
)


(defun putacad2 (txt pt0 s1 / nn fp ll rr rr2 txt pt0 cnt blanks once)
(setq nn notefile ll "x" rr 1 rr2 1 blanks 0 once 1)
(prompt "\n>> Searching for note no. ")(princ txt)(terpri)
(setq fp (open nn "r"))
   (while (and (/= ll nil) (/= txt nil) (= rr 1) (/= fp nil))
   (setq ll (read-line fp))
    (if (and (/= ll nil) (= (substr ll 1 1) "$") (= txt (atoi (substr ll 2 4))))
      (setq rr 0)
    ) 
   )
   (if (= rr 0) (progn
      (setq ll (read-line fp) cnt 1)
      (while (and (/= ll nil) (= rr2 1))
      (if (= (ascii ll) 9) (setq ll ""))  ;  IGNORES TABS
        (if (and (= cnt 1) (/= pt0 "") (/= pt0 nil) )
        (command "text" pt0 textheight "" ll)
        (command "text" "" ll)
        )
         (if (= once 1) (progn
         (setq lista (list (gpoint1 (entlast)) ))
         (setq listb (append listb lista) once 0)
         ))
      (setq ll (read-line fp) cnt (1+ cnt))
      (if (and (/= ll nil)  (or (= (substr ll 1 1) "$") (= (substr ll 1 1) "*")) )  (setq rr2 0))
        (if (and (/= ll nil) (= (strlen ll) 0)) 
        (if (= blanks 1) (setq rr2 0 blanks 0) (setq blanks 1))
        )
      )
   ))
(if (/= fp nil) (close fp))
(princ "\n \n \n")
(if (= rr 1) (setq status (append status (list txt))) )
(setq rr rr)
)



(defun search ( / r1 listc ll lx once xd x at1)
(setq once 0 xd "" lx "")
(setq fp1 (open notefile "r"))

(setq str1 (getstring "\n \nEnter search string:  " T))
(setq str1 (strcase str1))

(if (/= str1 "") (progn
(prompt "\n \n \n                         Searching Database\r")
(setq ll (read-line fp1))
  (while (/= ll nil) 
  (setq lx (substr ll 1 1))
  (if (= lx "*") (setq once 0))
    (if (= lx "$") (progn
    (setq nn (atoi (substr ll 2 5)) once 1)  
    (prompt "Note number:  ") (princ nn) (prompt "\r")
    ))
     (setq at1 (wcmatch ll (strcat "*" str1 "*")))
        (if (and (/= at1 nil) (= once 1))
        (setq listc (append listc (list nn)) once 0)
        )
  (setq ll (read-line fp1))
  )

(if (/= fp1 nil) (close fp1))

(if (= 0 (length listc)) 
  (progn
  (prompt "\n \n>>> There were no matching files !!")
  (getstring (prompt "\n>>> Push return to continue: "))
  (prompt "\n \n")
  )
  (progn
  (prompt "\n \nSearch string found ")(princ (length listc))
  (prompt " matching notes:  ")(princ listc)(prompt "\n")
  (setq x (getstring "Do you wish to view notes found  <Y> :  ") x (strcase x T))
  (if (= x "n") (setq x "q"))
    (if (and (/= x "n") (/= x "q")) (progn 
    (setq x (searchscr listc))
    ))
  )
)

))

(setq x x)
)




(defun searchscr (listp / fp1 sx nt cnt)
(setq nt "" sx "" cnt 0)

(while (and (/= nt "no") (/= nt "n") (/= nt "q") (/= sx "quit") (/= sx "insertnote") (/= sx "goto"))
(setq fp1 (open notefile "r") sx "")
(setq ll (read-line fp1))
(if (= system1 "pc") (command "shell" "cls") (rtn 1))
(textscr)
(prompt "\n \nList of notes matching Searchfile:")
(prompt "\n----------------------------------\n")
(prompt "Matching notes are >> ") (princ listp) (prompt "\n \n \n")

  (while (and (/= ll nil) (/= sx "quit") (/= sx "insertnote") (/= sx "goto")) 
  (setq lx (substr ll 1 1))
  (if (= lx "*") (setq nn (- 0 10)) )
     (if (= lx "$") (progn
     (setq nn (atoi (substr ll 2 5)) ) 
        (if (or (member nn listp) (= listp nil)) (progn
        (setq cnt (1+ cnt))
          (if (> cnt 1) (progn
          (initget  "Goto Insertnote Help Quit N")(terpri)
          (setq sx (getkword "Goto/InsertNote/Quit >> ")) (rtn 2)
          (if (/= sx nil) (setq sx (strcase sx T)) )
          (if (= sx "quit") (graphscr))
          ))
        ))
     ))  
       (if (or (member nn listp) (= listp nil))  (progn
       (if (and (/= sx "insertnote") (/= sx "goto") (/= sx "quit")) (princ ll)) 
       (terpri) 
       ))
  (setq ll (read-line fp1))
  )

(if (/= fp1 nil) (close fp1))

   (if (and (/= sx "quit") (/= sx "insertnote") (/= sx "goto")) (progn

          (initget  "Goto Insertnote Help Quit N")(terpri)
          (setq sx (getkword "Goto/InsertNote/Quit >>> ")) (rtn 2)
          (if (/= sx nil) (setq sx (strcase sx T)) )
          (if (= sx "quit") (graphscr))

     (if (= sx "") (progn
     (prompt "\n \n<<<  E N D    O F    F I L E  >>>\n")
     (setq nt (getstring "\nDo you wish to continue <Y> :  ") nt (strcase nt T))
     (if (/= nt "n") (progn (setq cnt 0) (rtn 3)) )
     ))
   ))
)

(setq sx sx)
)



(defun viewscr (num / fp1 sx cnt nt)
(if (= system1 "pc") (command "shell" "cls") (rtn 3))
(textscr)
(prompt "\n \nList of notes:")
(prompt "\n------------------------\n \n")
(setq nt "" sx "")

(while (and (/= nt "n") (/= nt "no") (/= sx "quit") (/= sx "insertnote") (/= sx "goto"))
(setq fp1 (open notefile "r") sx "")
(setq ll (read-line fp1) cnt 0)

  (while (and (/= ll nil) (/= sx "quit") (/= sx "insertnote") (/= sx "help") (/= sx "goto") ) 
  (setq lx (substr ll 1 1))
  (if (= lx "*") (setq nn (- 0 10)) )
     (if (= lx "$") (progn
     (setq nn (atoi (substr ll 2 5)) ) 
     (if (> nn num) (setq cnt (1+ cnt)) )
        (if (and (>= nn num) (> cnt 0)) (progn
        (initget  "Goto Insertnote Help Quit N")(terpri)
        (setq sx (getkword "Goto/InsertNote/Quit >> ")) (rtn 2)
        (if (/= sx nil) (setq sx (strcase sx T)) )
        (if (= sx "quit") (graphscr))
        ))
     ))  
       (if (and (>= nn num) (/= sx "quit"))  (progn
       (princ ll) (terpri) 
       ))
  (setq ll (read-line fp1))
  )
  (if (and (/= sx "quit") (/= sx "insertnote") (/= sx "help") (/= sx "goto") ) (progn 
    (if (= ll nil) (getstring "\n \n>>  <<<  E N D    O F    F I L E  >>>\n"))
    (setq nt (getstring "\nDo you wish to continue <Y> :  ") nt (strcase nt T))
  ))
(if (/= fp1 nil) (close fp1))
)
(if (= sx "quit") (setq sx ""))
(setq sx sx)
)


(defun help1 ()
(if (= system1 "pc") (command "shell" "cls") (rtn 5))
(rtn 1)(textscr)
(prompt "                        << GETNOTES.LSP by Art Flood >>\n")
(prompt "                        _______________________________\n")
(prompt "                        -------------------------------\n \n \n")
(prompt "  Directions:\n")
(prompt "  -----------\n \n")
(prompt "  This program inserts notes from the text file STDNOTES.TXT into ACAD.\n")
(prompt "  To Insert Notes into ACAD, Select INSERTNOTE from the menu.  \n")
(prompt "  You may quit at any time by entering a \"Q\" at the prompt   >>  Q")
(rtn 3)
(prompt "  Examples of Ways to Enter Notes:\n")
(prompt "  --------------------------------\n \n")
(prompt "  >> 1,2,3,4,5,6,7,8         (enters notes 1 thru 8)\n \n")
(prompt "  >> 1-8                     (enters notes 1 thru 8)\n \n")
(prompt "  >> 1-3,7,8                 (enters notes 1,2,3,7,8)")
(setq x (getstring "\n \n \n >> "))
(graphscr)
(setq x x)
)


(defun parsenum1 (xx / aa t ax)
(setq aa (parsenum xx) ax nil)
   (foreach t aa
   (setq ax (append ax (parsedash t))) 
   )
(setq ax ax)
)


(defun parsenum (ss / x pos pos1 pos2 sx)
(setq pos (charpos ss ",") sx nil)
  (while (/= pos nil)
  (setq pos1 (- pos 1) pos2 (+ pos 1)) 
  (setq x (substr ss 1 pos1) )
  (setq ss (substr ss pos2 (strlen ss) ))
  (setq sx (append sx (list x) ))
  (setq pos (charpos ss ","))
  )
(setq sx (append sx (list ss) ))
)


(defun parsedash (sa / x x2 pos sx ss)
(setq pos (charpos sa "-") ss nil sx nil)
(if (/= pos nil) (setq pos1 (- pos 1) pos2 (+ pos 1) sx nil) )
  (if (/= pos nil) (progn
  (setq x (atoi (substr sa 1 pos1)) x2 (atoi (substr sa pos2 99)))
     (repeat (+ (- x2 x) 1)
     (setq ss (append ss (list (rtos x 5)) ))
     (setq x (1+ x))
     )
  ))
(if (/= ss nil) (setq ss ss) (list sa))
)


(defun charpos (s1 c2 / ix tt)
(setq ll (strlen s1) ix 1 tt 1)
  (while (and (<= ix ll) (= tt 1))
  (if (= (substr s1 ix 1) c2) (setq tt 0))
  (setq ix (1+ ix))
  )
(if (= tt 0) (- ix 1) (setq ix nil))
)


(defun rtn (ix)
(repeat ix (prompt " \n"))
)


(defun putnum (/ ii fac pt2)
(setq ii 0 fac gap1)
   (repeat (length listb)
   (if (> note0 9) (setq fac (* gap1 1.10) ))
   (setq pt2 (movept (nth ii listb) (- (* fac textheight)) 0))
   (setq pt2 (trans pt2 1 0))
   (setq note00 (strcat (rtos note0 5) "."))
   (command "text" pt2 "" "" note00)
   (setq ii (1+ ii) note0 (1+ note0))
   )
)


(defun movept (pt1 x y / )
(setq pt1   (list  (+ (car pt1) x )  (+ (cadr pt1) y ) ) )
)


(defun gpoint1 (a / xx)
(setq xx (entget a))
(cdr (assoc 10 xx))
)



(defun checkout ()
 (if (/= status nil) (progn
   (if (= system1 "pc") (command "shell" "cls") (rtn 4))
   (textscr) (princ (chr 7))
   (rtn 2)
   (prompt "> > > > > >  These Note numbers were not found : \n") 
   (prompt "-------------------------------------------------")
     (foreach xx status 
     (prompt "\n \nNote number ")(princ xx)
     )
   (getstring "\n \n \n>>  Push return to Continue:  ")
(rtn 2) 
))
)


(defun c:gn ()
(c:getnotes)
)


