     While going over the student wish-lists from the AutoLISP 
seminars, we found several requests for single key stroke macros. 
I no sooner said I would do up an example for Cave, Bill 
responded don't bother it's done, and pulled the "E1" example 
from his bag of tricks for Version 2.5x. The second version "E2" 
shows a similar function I through together for Version 2.6x 
using the (getkword) and (initget) functions.

; ==================================================
;
; Written by: Bill Kramer - Kramer Consulting, Inc.
;
;  Function Description
;     L       Line
;     A       Arc
;     T       Text
;     E       Edit commands: <Move, Change, 
;                             Copy, Erase>
;     C       Circle
;
; =========================================================
;
(defun C:L ( / S)
  (command "LINE") (setq S 'LINE))
;
(defun C:T ( / S)
  (command "TEXT") (setq S 'TEXT))
;
(defun C:A ( / S)
  (command "ARC") (setq S 'ARC))
;
(defun C:C ()
  (command 'CIRCLE))
;
; "E"dit function from Bill for Version 2.5x
;
(defun C:E1 ( / Exit Key)
   (setvar "HIGHLIGHT" 1)
   (setq Exit nil)
   (while (null Exit)
    (prompt "\nEdit commands [Copy, Move, cHange, Erase, Last, Quit]")
    (while (/= (car (setq Key (grread))) 2))
    (setq Key (strcase (chr (cadr Key))))
    (cond
      ((or (= Key (chr 13)) (= Key "Q") (= Key " ")) (setq Exit "Quit"))
      ((= Key "C") (setq Exit "Copy"))
      ((= Key "M") (setq Exit "Move") )
      ((= Key "H") (setq Exit "Change"))
      ((= Key "E") (setq Exit "Erase"))
      ((= Key "L") (command "Erase" "L" ""))))
   (if (/= Exit "Quit") (progn (prompt Exit) (command Exit)))
)
;
; New "E"dit function from the Cave for Version 2.6x
;
(defun C:E2 ( / Key Keys)
   (initget 1 (setq Keys "Copy Move cHange Erase Stretch"))   
   (prompt (strcat "\nEnter Command [ " Keys " ] "))
   (setq Key (getkword))
   (command Key)
   (setq Key 'Completed)
)
